<?php

if(!defined('_PS_VERSION_'))
exit;

class ecm_cmlid extends Module{
	/* @var boolean error */
	protected $_errors = false;
	private $_html = '';

	public
	function __construct(){
		$this->name = 'ecm_cmlid';
		$this->tab = 'content_management';
		$this->version = '1.2';
		$this->author = 'Elcommerce';
		$this->need_instance = 0;
		$this->bootstrap = true;
		parent::__construct();

		$this->displayName = $this->l('CommerceML id');
		$this->description = $this->l('Adds a tab for view/change CommerceML identifier');
		$check_xml = Db::getInstance()->ExecuteS("SHOW COLUMNS FROM `"._DB_PREFIX_."product` WHERE `Field` = 'xml'");
		if(empty($check_xml)) $this->warning = $this->l('Maybe not set the synchronization module!');
	}
	public
	function install(){
		if(!parent::install()
			|| !$this->registerHook('DisplayAdminProductsExtra')
			|| !$this->registerHook('displayBackOfficeCategory')
			|| !$this->registerHook('actionCategoryUpdate')
		)
		return false;
		return true;
	}

	public
	function uninstall()
	{
		if(!parent::uninstall())
			return FALSE;
		return TRUE;
	}
	public
	function hookDisplayBackOfficeCategory($params){
		if(Validate::isLoadedObject($category = new Category((int)Tools::getValue('id_category')))){
			$check_xml = Db::getInstance()->ExecuteS("SHOW COLUMNS FROM `"._DB_PREFIX_."category` WHERE `Field` = 'xml'");
		if (empty($check_xml)) $res = 0; else $res = 1;
		$sql = "SELECT `xml` FROM `"._DB_PREFIX_."category` WHERE `id_category` = " . (int)$category->id;
		$xml = Db::getInstance()->getValue($sql);
		$this->context->smarty->assign(array(
				'id_category' =>$category->id,
				'xml' => $xml,
				'varning' => $res
			));
			return $this->display(__FILE__, 'ecm_cmlidCat.tpl');
		}
	}
	public
	function hookActionCategoryUpdate($params){
		$id_category	= (int)Tools::getValue('id_category');
		Db::getInstance()->update('category', array('xml'=> Tools::getValue('xml_id')),'id_category = '.$id_category);
	}
	public
	function hookDisplayAdminProductsExtra($params){
		if(Validate::isLoadedObject($product = new Product((int)Tools::getValue('id_product')))){
			$this->prepareNewTab();
			return $this->display(__FILE__, 'ecm_cmlid.tpl');
		}
	}

	public
	function prepareNewTab(){
		$check_xml = Db::getInstance()->ExecuteS("SHOW COLUMNS FROM `"._DB_PREFIX_."product` WHERE `Field` = 'xml'");
		if (empty($check_xml)) $res = 0; else $res = 1;
		$id_product = (int)Tools::getValue('id_product');
		$this->context->smarty->assign(array(
				'id_product' => $id_product,
				'xml' => $this->getCMLid($id_product),
				'xml_c' => $this->getCMLidComb($id_product),
				'varning' => $res
			));
	}

	public
	function getCMLid($id_product){
		$sql = "SELECT `xml` FROM `"._DB_PREFIX_."product` WHERE `id_product` = " . (int)$id_product;
		$result = Db::getInstance()->getValue($sql);
		if(!$result) return "Not assign !!!";

		return $result;
	}

	function getCMLidComb($id_product){
		$idlang = Configuration::get('PS_LANG_DEFAULT');
		$sql = "
			SELECT pa.`id_product_attribute`, CONCAT (agl.`name`, ' - ', al.`name`) name, pa.`xml`
			FROM `"._DB_PREFIX_."product_attribute` pa
			LEFT JOIN `"._DB_PREFIX_."product_attribute_combination` pac ON pac.`id_product_attribute` = pa.`id_product_attribute`
			LEFT JOIN `"._DB_PREFIX_."attribute` a ON pac.`id_attribute` = a.`id_attribute`
			LEFT JOIN `"._DB_PREFIX_."attribute_group` ag ON ag.`id_attribute_group` = a.`id_attribute_group`
			LEFT JOIN `"._DB_PREFIX_."attribute_group_lang` agl ON agl.`id_attribute_group` = ag.`id_attribute_group`  AND agl.`id_lang` = '$idlang'
			LEFT JOIN `"._DB_PREFIX_."attribute_lang` al ON pac.`id_attribute` = al.`id_attribute` AND al.`id_lang` = '$idlang'
			WHERE pa.`id_product` = '$id_product'
			";
		$combination = Db::getInstance()->ExecuteS($sql);
		//p($combination);
		foreach ($combination as $res){
			$id = $res['id_product_attribute'];
			$xml = $res['xml'];
			foreach ($combination as $res_){
				if ($id == $res_['id_product_attribute']) $name[] = $res_['name'];
			}
			asort($name);
			$data[$id] = array (
				'id'=>$id,
				'name'=>implode(', ',$name),
				'xml'=>$xml
			);
			unset ($name);
		}
		if (!isset($data)) return "Not assign !!!";
		return $data;
	}


	private
	function _displayInfo(){
		$check_xml = Db::getInstance()->ExecuteS("SHOW COLUMNS FROM `"._DB_PREFIX_."product` WHERE `Field` = 'xml'");
		if (empty($check_xml)) $res = 0; else $res = 1;
		$this->context->smarty->assign(
			array(
				'version' => $this->version,
				'author' => $this->author,
				'varning' => $res
			)
		);
		return $this->display(__FILE__, 'infos.tpl');
	}

	function getContent(){
		$this->_html .= '<br />';
		$this->_html .= $this->_displayInfo();

		return $this->_html;
	}
}